package net.helcel.beendroid.countries

import net.helcel.beendroid.countries.Country.*
import net.helcel.beendroid.countries.State.*

enum class Country(override val fullName: String, override val area : Int, override val children : List<GeoLoc>) : GeoLoc {
    AFG("Afghanistan", 652864, emptyList()),
    ALA("Åland Islands", 1580, emptyList()),
    ALB("Albania", 28748, emptyList()),
    DZA("Algeria", 2381741, emptyList()),
    ASM("American Samoa", 199000, emptyList()),
    AND("Andorra", 468765, emptyList()),
    AGO("Angola", 1246700, emptyList()),
    AIA("Anguilla", 96, emptyList()),
    ATA("Antarctica", 14000000, emptyList()),
    ATG("Antigua and Barbuda", 442, emptyList()),
    ARG("Argentina", 2780400, emptyList()),
    ARM("Armenia", 29743, emptyList()),
    ABW("Aruba", 180, emptyList()),
    AUS("Australia", 7692024, emptyList()),
    AUT("Austria", 83879, emptyList()),
    AZE("Azerbaijan", 86600, emptyList()),
    BHS("Bahamas", 13878, emptyList()),
    BHR("Bahrain", 778, emptyList()),
    BGD("Bangladesh", 143998, emptyList()),
    BRB("Barbados", 430, emptyList()),
    BLR("Belarus", 207595, emptyList()),
    BEL("Belgium", 30528, emptyList()),
    BLZ("Belize", 22965, emptyList()),
    BEN("Benin", 114763, emptyList()),
    BMU("Bermuda", 54, emptyList()),
    BTN("Bhutan", 38394, emptyList()),
    BOL("Bolivia (Plurinational State of)", 1098581, emptyList()),
    BES("Bonaire, Sint Eustatius and Saba", 294, emptyList()),
    BIH("Bosnia and Herzegovina", 51209, emptyList()),
    BWA("Botswana", 581730, emptyList()),
    BVT("Bouvet Island", 49, emptyList()),
    BRA("Brazil", 8515767, emptyList()),
    IOT("British Indian Ocean Territory", 60, emptyList()),
    BRN("Brunei Darussalam", 5765, emptyList()),
    BGR("Bulgaria", 110994, emptyList()),
    BFA("Burkina Faso", 274200, emptyList()),
    BDI("Burundi", 27834, emptyList()),
    CPV("Cabo Verde", 4033, emptyList()),
    KHM("Cambodia", 181035, emptyList()),
    CMR("Cameroon", 475442, emptyList()),
    CAN("Canada", 9984670, emptyList()),
    CYM("Cayman Islands", 264, emptyList()),
    CAF("Central African Republic", 622436, emptyList()),
    TCD("Chad", 1284000, emptyList()),
    CHL("Chile", 756102, emptyList()),
    CHN("China", 9596961, emptyList()),
    CXR("Christmas Island", 135, emptyList()),
    CCK("Cocos (Keeling) Islands", 14, emptyList()),
    COL("Colombia", 1141748, emptyList()),
    COM("Comoros", 2235, emptyList()),
    COG("Congo", 342000, emptyList()),
    COD("Congo, Democratic Republic of the", 2344858, emptyList()),
    COK("Cook Islands", 237, emptyList()),
    CRI("Costa Rica", 51100, emptyList()),
    CIV("Côte d'Ivoire", 322463, emptyList()),
    HRV("Croatia", 56594, emptyList()),
    CUB("Cuba", 109884, emptyList()),
    CUW("Curaçao", 444, emptyList()),
    CYP("Cyprus", 9251, emptyList()),
    CZE("Czech Republic", 78865, emptyList()),
    DNK("Denmark", 42933, emptyList()),
    DJI("Djibouti", 23200, emptyList()),
    DMA("Dominica", 750, emptyList()),
    ECU("Ecuador", 276841, emptyList()),
    EGY("Egypt", 1002450, emptyList()),
    SLV("El Salvador", 21041, emptyList()),
    GNQ("Equatorial Guinea", 28051, emptyList()),
    ERI("Eritrea", 117600, emptyList()),
    EST("Estonia", 45227, emptyList()),
    SWZ("Eswatini", 17364, emptyList()),
    ETH("Ethiopia", 1104300, emptyList()),
    FLK("Falkland Islands (Malvinas)", 12173, emptyList()),
    FRO("Faroe Islands", 1399, emptyList()),
    FJI("Fiji", 18333, emptyList()),
    FIN("Finland", 338424, emptyList()),
    FRA("France", 643801, emptyList()),
    GUF("French Guiana", 83534, emptyList()),
    PYF("French Polynesia", 4167, emptyList()),
    ATF("French Southern Territories", 7747, emptyList()),
    GAB("Gabon", 267667, emptyList()),
    GMB("Gambia", 11295, emptyList()),
    GEO("Georgia", 69700, emptyList()),
    DEU("Germany", 357408, listOf(DEU_BY, DEU_BE, DEU_BB, DEU_HB, DEU_HH, DEU_HE, DEU_MV, DEU_NI, DEU_NW, DEU_RP, DEU_SL, DEU_SN, DEU_ST, DEU_SH, DEU_TH)),
    GHA("Ghana", 238533, emptyList()),
    GIB("Gibraltar", 6, emptyList()),
    GRC("Greece", 131957, emptyList()),
    GRL("Greenland", 2166086, emptyList()),
    GRD("Grenada", 344, emptyList()),
    GLP("Guadeloupe", 1628, emptyList()),
    GUM("Guam", 541, emptyList()),
    GTM("Guatemala", 108889, emptyList()),
    GGY("Guernsey", 78, emptyList()),
    GIN("Guinea", 245857, emptyList()),
    GNB("Guinea-Bissau", 36125, emptyList()),
    GUY("Guyana", 214969, emptyList()),
    HTI("Haiti", 27750, emptyList()),
    HMD("Heard Island and McDonald Islands", 412, emptyList()),
    VAT("Holy See (Vatican)", 1, emptyList()),
    HND("Honduras", 112492, emptyList()),
    HKG("Hong Kong", 1104, emptyList()),
    HUN("Hungary", 93028, emptyList()),
    ISL("Iceland", 102775, emptyList()),
    IND("India", 3287263, emptyList()),
    IDN("Indonesia", 1904569, emptyList()),
    IRN("Iran (Islamic Republic of)", 1648195, emptyList()),
    IRQ("Iraq", 438317, emptyList()),
    IRL("Ireland", 70273, emptyList()),
    IMN("Isle of Man", 572, emptyList()),
    ISR("Israel", 22072, emptyList()),
    ITA("Italy", 301340, emptyList()),
    JAM("Jamaica", 10991, emptyList()),
    JPN("Japan", 377915, listOf(JPN_HO, JPN_AO, JPN_IW, JPN_MI, JPN_AK, JPN_YA, JPN_FU, JPN_IB, JPN_TO, JPN_GU, JPN_SA, JPN_CH, JPN_TY, JPN_KA, JPN_NI, JPN_TOY, JPN_ISH, JPN_FK, JPN_YAM, JPN_NG, JPN_GI, JPN_SHI, JPN_AI, JPN_ME, JPN_SG, JPN_KY, JPN_OS, JPN_HY, JPN_NA, JPN_WK, JPN_TO, JPN_SM, JPN_OK, JPN_HR, JPN_YG, JPN_TS, JPN_KG, JPN_EH, JPN_KC, JPN_FK, JPN_SG, JPN_NG, JPN_KM, JPN_OT, JPN_MY, JPN_KG, JPN_OK)),
    JEY("Jersey", 118, emptyList()),
    JOR("Jordan", 89342, emptyList()),
    KAZ("Kazakhstan", 2724900, emptyList()),
    KEN("Kenya", 580367, emptyList()),
    KIR("Kiribati", 811, emptyList()),
    PRK("Korea (Democratic People's Republic of)", 120538, emptyList()),
    KOR("Korea, Republic of", 100210, emptyList()),
    XKO("Kosovo", 10887, emptyList()),
    KWT("Kuwait", 17818, emptyList()),
    KGZ("Kyrgyzstan", 199900, emptyList()),
    LAO("Lao People's Democratic Republic", 236800, emptyList()),
    LVA("Latvia", 64559, emptyList()),
    LBN("Lebanon", 10452, emptyList()),
    LSO("Lesotho", 30355, emptyList()),
    LBR("Liberia", 111369, emptyList()),
    LBY("Libya", 1759540, emptyList()),
    LIE("Liechtenstein", 160, emptyList()),
    LTU("Lithuania", 65300, emptyList()),
    LUX("Luxembourg", 2586, emptyList()),
    MAC("Macao", 32, emptyList()),
    MDG("Madagascar", 587041, emptyList()),
    MWI("Malawi", 118484, emptyList()),
    MYS("Malaysia", 330803, emptyList()),
    MDV("Maldives", 300, emptyList()),
    MLI("Mali", 1240192, emptyList()),
    MLT("Malta", 316, emptyList()),
    MHL("Marshall Islands", 181, emptyList()),
    MTQ("Martinique", 1128, emptyList()),
    MRT("Mauritania", 1030700, emptyList()),
    MUS("Mauritius", 2040, emptyList()),
    MYT("Mayotte", 374, emptyList()),
    MEX("Mexico", 1964375, emptyList()),
    FSM("Micronesia (Federated States of)", 702, emptyList()),
    MDA("Moldova, Republic of", 33846, emptyList()),
    MCO("Monaco", 2, emptyList()),
    MNG("Mongolia", 1564116, emptyList()),
    MNE("Montenegro", 13812, emptyList()),
    MSR("Montserrat", 102, emptyList()),
    MAR("Morocco", 446550, emptyList()),
    MOZ("Mozambique", 799380, emptyList()),
    MMR("Myanmar", 676578, emptyList()),
    NAM("Namibia", 824292, emptyList()),
    NRU("Nauru", 21, emptyList()),
    NPL("Nepal", 147181, emptyList()),
    NLD("Netherlands", 41526, emptyList()),
    NCL("New Caledonia", 18575, emptyList()),
    NZL("New Zealand", 270467, emptyList()),
    NIC("Nicaragua", 130373, emptyList()),
    NER("Niger", 1267000, emptyList()),
    NGA("Nigeria", 923768, emptyList()),
    NIU("Niue", 261, emptyList()),
    NFK("Norfolk Island", 35, emptyList()),
    MNP("Northern Mariana Islands", 457, emptyList()),
    NOR("Norway", 385207, emptyList()),
    OMN("Oman", 309500, emptyList()),
    PAK("Pakistan", 881913, emptyList()),
    PLW("Palau", 459, emptyList()),
    PSE("Palestine, State of", 6220, emptyList()),
    PAN("Panama", 75417, emptyList()),
    PNG("Papua New Guinea", 462840, emptyList()),
    PRY("Paraguay", 406752, emptyList()),
    PER("Peru", 1285216, emptyList()),
    PHL("Philippines", 300000, emptyList()),
    PCN("Pitcairn", 47, emptyList()),
    POL("Poland", 312696, emptyList()),
    PRT("Portugal", 92090, emptyList()),
    PRI("Puerto Rico", 9104, emptyList()),
    QAT("Qatar", 11586, emptyList()),
    MKD("Republic of North Macedonia", 25713, emptyList()),
    ROU("Romania", 238391, emptyList()),
    RUS("Russian Federation", 17125242, emptyList()),
    RWA("Rwanda", 26338, emptyList()),
    REU("Réunion", 2511, emptyList()),
    BLM("Saint Barthélemy", 21, emptyList()),
    SHN("Saint Helena, Ascension and Tristan da Cunha", 394, emptyList()),
    KNA("Saint Kitts and Nevis", 270, emptyList()),
    LCA("Saint Lucia", 617, emptyList()),
    MAF("Saint Martin (French part)", 53, emptyList()),
    SPM("Saint Pierre and Miquelon", 242, emptyList()),
    VCT("Saint Vincent and the Grenadines", 389, emptyList()),
    WSM("Samoa", 2831, emptyList()),
    SMR("San Marino", 61, emptyList()),
    STP("Sao Tome and Principe", 1001, emptyList()),
    SAU("Saudi Arabia", 2149690, emptyList()),
    SEN("Senegal", 196722, emptyList()),
    SRB("Serbia", 88361, emptyList()),
    SYC("Seychelles", 459, emptyList()),
    SLE("Sierra Leone", 71740, emptyList()),
    SGP("Singapore", 725, emptyList()),
    SXM("Sint Maarten (Dutch part)", 34, emptyList()),
    SVK("Slovakia", 49036, emptyList()),
    SVN("Slovenia", 20273, emptyList()),
    SLB("Solomon Islands", 28896, emptyList()),
    SOM("Somalia", 637657, emptyList()),
    ZAF("South Africa", 1221037, emptyList()),
    SGS("South Georgia and the South Sandwich Islands", 3903, emptyList()),
    SSD("South Sudan", 619745, emptyList()),
    ESP("Spain", 505990, emptyList()),
    LKA("Sri Lanka", 65610, emptyList()),
    SDN("Sudan", 1839542, emptyList()),
    SUR("Suriname", 163820, emptyList()),
    SJM("Svalbard and Jan Mayen", 61399, emptyList()),
    SWE("Sweden", 450295, emptyList()),
    CHE("Switzerland", 41284, listOf(CHE_AG, CHE_AR, CHE_AI, CHE_BL, CHE_BS, CHE_BE, CHE_FR, CHE_GE, CHE_GL, CHE_GR, CHE_JU, CHE_LU, CHE_NE, CHE_NW, CHE_OW, CHE_SH, CHE_SZ, CHE_SO, CHE_SG, CHE_TG, CHE_TI, CHE_UR, CHE_VS, CHE_VD, CHE_ZG, CHE_ZH)),
    SYR("Syrian Arab Republic", 185180, emptyList()),
    TWN("Taiwan, Province of China", 36193, emptyList()),
    TJK("Tajikistan", 143100, emptyList()),
    TZA("Tanzania, United Republic of", 947300, emptyList()),
    THA("Thailand", 513120, emptyList()),
    TLS("Timor-Leste", 14919, emptyList()),
    TGO("Togo", 56785, emptyList()),
    TKL("Tokelau", 12, emptyList()),
    TON("Tonga", 747, emptyList()),
    TTO("Trinidad and Tobago", 5128, emptyList()),
    TUN("Tunisia", 163610, emptyList()),
    TUR("Turkey", 783562, emptyList()),
    TKM("Turkmenistan", 488100, emptyList()),
    TCA("Turks and Caicos Islands", 948, emptyList()),
    TUV("Tuvalu", 26, emptyList()),
    UGA("Uganda", 241551, emptyList()),
    UKR("Ukraine", 603700, emptyList()),
    ARE("United Arab Emirates", 83600, emptyList()),
    GBR("United Kingdom of Great Britain and Northern Ireland", 242910, emptyList()),
    USA("United States of America", 9833517, emptyList()),
    UMI("United States Minor Outlying Islands", 34, emptyList()),
    URY("Uruguay", 176215, emptyList()),
    UZB("Uzbekistan", 447400, emptyList()),
    VUT("Vanuatu", 12189, emptyList()),
    VEN("Venezuela (Bolivarian Republic of)", 912050, emptyList()),
    VNM("Viet Nam", 331212, emptyList()),
    VGB("Virgin Islands (British", 153, emptyList()),
    VIR("Virgin Islands (U.S.)", 347, emptyList()),
    WLF("Wallis and Futuna", 142, emptyList()),
    ESH("Western Sahara", 266000, emptyList()),
    YEM("Yemen", 527968, emptyList()),
    ZMB("Zambia", 752612, emptyList()),
    ZWE("Zimbabwe", 390757, emptyList()),
    DOM("Dominican Republic", 48671, emptyList()),
    ANT("Netherlands Antilles", 800, emptyList()),
    XAD("Akrotiri and Dhekelia", 254, emptyList()),
    XCL("Clipperton Island", 6, emptyList()),
    ZNC("Nothern Cyprus", 3355, emptyList()),
    ;


    override val code = this.name
    override val type = LocType.COUNTRY
}

